LeetCode 300. Longest Increasing Subsequence

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

nlgn ---- no idea now how to solve it.


#include <vector>
#include <iostream>
#include <climits>
#include <algorithm>
using namespace std;

// longest increasing sequence.
// dp[i] = max(dp[i], dp[j] + 1) if(a[j] < a[i]), i >= 0 && i <= nums.size(); j >= 0 && j < i;
int lengthOfLIS(vector<int>& nums) {
    if(nums.size() <= 1) return nums.size();
    vector<int> dp(nums.size() + 1, 1);

    for(int i = 1; i <= nums.size(); ++i) {
        for(int j = 0; j < i; ++j) {
            if(nums[j] < nums[i]) {
                dp[i] = max(dp[j] + 1, dp[i]);
            }
        }
    }
    int maxLen = INT_MIN;
    for(int i = 0; i < nums.size(); ++i) {
        maxLen = max(maxLen, dp[i]);
    }
    return maxLen;
}

int main(void) {
    vector<int> nums{10, 9, 2, 5, 3, 7, 101, 18};
    int length = lengthOfLIS(nums);
    cout << length << endl;
}


你可能感兴趣的:(LeetCode 300. Longest Increasing Subsequence)